#include "header.h"
#include "FILE/nrutil.h"
#include "FILE/stat.c"
#include "FILE/cost1.c"
#include "FILE/cost2.c"
#include "FILE/update_cost2.c"
#include "FILE/gibbs1P.c"
#include "FILE/gibbs1E.c"
#include "FILE/gibbs2P.c"
#include "FILE/gibbs2E.c"
#include "FILE/normsinv.h"

int main (int argc, const char * argv[]) {

	long ltime;
	int stime;
	ltime = time(NULL);
	stime = (unsigned int)ltime/2;
	srand(stime);

	//RNORM2(x, mu, A, n);
	
	MM = atoi(argv[1]); RUNN = atoi(argv[2]);
	
	char buf[255], frname[255];
	FILE *inp, *inp1, *inp2, *inp3, *inp4, *inp5, *inp6, *inp7, *inp8, *inp9, *inp0;
	FILE *out1, *out2, *out3, *out4, *out5;
	int a, b, i, j, k, iter, address;
	int count_A, count_P, count_R, indicator_A, indicator_P, indicator_R;
	double U, fyOLD, fxNEW, fxOLD, fyNEW, pr, aprob, r, effectsum_A;
	double var1, var2, sd1, sd2, sumijs1, sumijs2, fxrho, fyrho; 
	double newcop_A, *newcop_P, oldcop_A, *oldcop_P, accept_A, accept_P, accept_R;
	double temp, temp_old, temp_new, prcheck1, prcheck2, spat_A, spat_P, *gen, *mu, **Sigma;
	int tmpA1, tmpA2, tmpP1, tmpP2, tmpP3, tmpP4;

	COV = dmatrix(1, INDIV, 1, nCOV);
	COEF_A = dmatrix(1, INDIV, 1, nCOEF1);
	COEF_P = dmatrix(1, 2 * INDIV, 1, nCOEF2);
	prop = dvector(1, nCOEF2);
	
	for(i = 1; i <= INDIV; i++)
		for(j = 1; j <= nCOV; j++) COV[i][j] = 0.0;
    
	inp = fopen("DATA/COV.dat", "r");
	if(inp == NULL) {printf("Cannot open data file\n"); return 0;}
	for(i = 1; i <= INDIV; i++)
		for(j = 1; j <= nCOV; j++) fscanf(inp, "%lf", &COV[i][j]);
	fclose(inp);
	
	for(i = 1; i <= nCOEF2; i++) prop[i] = 0.0;
	for(i = 1; i <= INDIV; i++){
		if(COV[i][3] == 1) prop[1] += 1.0 / INDIV;
		if(COV[i][6] == 1 && COV[i][7] == 1) prop[2] += 1.0 / INDIV;
		if(COV[i][8] == 1) prop[3] += 1.0 / INDIV;
		prop[4] += COV[i][1] / INDIV;
		prop[5] += COV[i][9] / INDIV;
	}
	for(i = 1; i <= nCOEF1; i++) printf("%.2f ", prop[i]);
	printf("\n");
	
	for(var1 = 0.0, i = 1; i <= INDIV; i++) var1 += (COV[i][1] - prop[4]) * (COV[i][1] - prop[4]) / (INDIV - 1.0); sd1 = sqrt(var1);
	for(var2 = 0.0, i = 1; i <= INDIV; i++) var2 += (COV[i][9] - prop[5]) * (COV[i][9] - prop[5]) / (INDIV - 1.0); sd2 = sqrt(var2);
    
	for(k = 1; k <= INDIV; k++) {
		if(COV[k][3] == 1.0) COEF_A[k][1] = 1.0 - prop[1];
		else COEF_A[k][1] = -1.0 * prop[1];
		if(COV[k][6] == 1.0 && COV[k][7] == 1.0) COEF_A[k][2] = 1.0 - prop[2];
		else COEF_A[k][2] = -1.0 * prop[2];
		if(COV[k][8] == 1.0) COEF_A[k][3] = 1.0 - prop[3];
		else COEF_A[k][3] = -1.0 * prop[3];
		COEF_A[k][4] = (COV[k][1] - prop[4]) / sd1 * 0.5;
		COEF_A[k][5] = COEF_A[k][4] * COEF_A[k][4];
		COEF_A[k][6] = (COV[k][9] - prop[5]) / sd2 * 0.5;
		COEF_A[k][7] = COEF_A[k][6] * COEF_A[k][6];
	}
    
	for(k = 1; k <= 2 * INDIV; k++) {
		if(k % 2 == 1) address = (k + 1) / 2;
		else address = k / 2;
        
		if(COV[address][3] == 1.0) COEF_P[k][1] = 1.0 - prop[1];
		else COEF_P[k][1] = -1.0 * prop[1];
		if(COV[address][6] == 1.0 && COV[address][7] == 1.0) COEF_P[k][2] = 1.0 - prop[2];
		else COEF_P[k][2] = -1.0 * prop[2];
		if(COV[address][8] == 1.0) COEF_P[k][3] = 1.0 - prop[3];
		else COEF_P[k][3] = -1.0 * prop[3];
		COEF_P[k][4] = (COV[address][1] - prop[4]) / sd1 * 0.5;
		COEF_P[k][5] = COEF_P[k][4] * COEF_P[k][4];
		COEF_P[k][6] = (COV[address][9] - prop[5]) / sd2 * 0.5;
		COEF_P[k][7] = COEF_P[k][6] * COEF_P[k][6];
	}
    
	Yeffstat_A = dvector(1, INDIV);
	Zeffstat_A = dvector(1, INDIV);
	Yeffstat_P = dvector(1, 2 * INDIV);
	Zeffstat_P = dvector(1, 2 * INDIV);
    
	theta_A = dvector(1, nPARA1 + nCOEF1);
	theta_P = dvector(1, nPARA2 + nCOEF2);
	newtheta_A = dvector(1, nPARA1 + nCOEF1);
	newtheta_P = dvector(1, nPARA2 + nCOEF2);
    
	neweffect_A = dvector(1, INDIV);
	neweffect_P = dvector(1, INDIV);
	oldeffect_A = dvector(1, INDIV);
	oldeffect_P = dvector(1, INDIV);
    
	int **ZBACK_A, **ZDATA_A, **YBACK_A, **YDATA_A;
    
	ZBACK_A = imatrix(1, 4 * INDIV, 0, TOOTH + 1);
	ZDATA_A = imatrix(1, 4 * INDIV, 0, TOOTH + 1);
	YBACK_A = imatrix(1, 4 * INDIV, 0, TOOTH + 1);
	YDATA_A = imatrix(1, 4 * INDIV, 0, TOOTH + 1);
	
	for(i = 1; i <= 4 * INDIV; i++)
		for(j = 0; j <= TOOTH + 1; j++) ZBACK_A[i][j] = ZDATA_A[i][j] = YBACK_A[i][j] = YDATA_A[i][j] = 0;

	tmpA1 = tmpA2 = 0;
	inp1 = fopen("DATA/UPJAW_BACK.dat", "r");
	inp2 = fopen("DATA/UPJAW_MISS.dat", "r");
	if(inp1 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp2 == NULL) {printf("Cannot open data file\n"); return 0;}
	for(i = 2; i <= 4 * INDIV - 2; i = i + 4)
		for(j = 1; j <= TOOTH; j++) {
			fscanf(inp1, "%d", &ZBACK_A[i][j]); 
			fscanf(inp2, "%d", &ZDATA_A[i][j]);
			if(ZBACK_A[i][j] == 1){
				if(ZDATA_A[i][j] == 1) tmpA1++;
				else tmpA2++;
			}
		}
	fclose(inp1);
	fclose(inp2);
	
	inp1 = fopen("DATA/LOJAW_BACK.dat", "r");
	inp2 = fopen("DATA/LOJAW_MISS.dat", "r");
	if(inp1 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp2 == NULL) {printf("Cannot open data file\n"); return 0;}
	for(i = 3; i <= 4 * INDIV - 1; i = i + 4)
		for(j = 1; j <= TOOTH; j++) {
			fscanf(inp1, "%d", &ZBACK_A[i][j]); 
			fscanf(inp2, "%d", &ZDATA_A[i][j]);
			if(ZBACK_A[i][j] == 1){
				if(ZDATA_A[i][j] == 1) tmpA1++;
				else tmpA2++;
			}
		}
	fclose(inp1);
	fclose(inp2);
	
	int ZBACK_P[6][563][15], ZDATA_P[6][563][15], YBACK_P[6][563][15], YDATA_P[6][563][15];
    
	for(k = 1; k <= 5; k++)
		for(i = 0; i <= 2 * INDIV; i++)
			for(j = 1; j <= TOOTH; j++) {
				ZBACK_P[1][i][j] = 0; ZDATA_P[1][i][j] = 0;
				ZBACK_P[2][i][j] = 0; ZDATA_P[2][i][j] = 0;
				ZBACK_P[3][i][j] = 0; ZDATA_P[3][i][j] = 0;
				ZBACK_P[4][i][j] = 0; ZDATA_P[4][i][j] = 0;
				ZBACK_P[5][i][j] = 0; ZDATA_P[5][i][j] = 0;
			}

	tmpP1 = tmpP2 = tmpP3 = tmpP4 = 0;
	inp1 = fopen("DATA/UPJAW_BACK_OCCLUSAL.dat", "r");
	inp2 = fopen("DATA/UPJAW_BACK_MESIAL.dat", "r");
	inp3 = fopen("DATA/UPJAW_BACK_DISTAL.dat", "r");
	inp4 = fopen("DATA/UPJAW_BACK_FACIAL.dat", "r");
	inp5 = fopen("DATA/UPJAW_BACK_LINGUAL.dat", "r");
	inp6 = fopen("DATA/UPJAW_OCCLUSAL.dat", "r");
	inp7 = fopen("DATA/UPJAW_MESIAL.dat", "r");
	inp8 = fopen("DATA/UPJAW_DISTAL.dat", "r");
	inp9 = fopen("DATA/UPJAW_FACIAL.dat", "r");
	inp0 = fopen("DATA/UPJAW_LINGUAL.dat", "r");
	if(inp1 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp2 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp3 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp4 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp5 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp6 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp7 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp8 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp9 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp0 == NULL) {printf("Cannot open data file\n"); return 0;}
	for(i = 1; i <= 2 * INDIV - 1; i = i + 2)
		for(j = 1; j <= TOOTH; j++){
			fscanf(inp1, "%d", &ZBACK_P[1][i][j]);
			fscanf(inp2, "%d", &ZBACK_P[2][i][j]);
			fscanf(inp3, "%d", &ZBACK_P[3][i][j]);
			fscanf(inp4, "%d", &ZBACK_P[4][i][j]);
			fscanf(inp5, "%d", &ZBACK_P[5][i][j]);
			fscanf(inp6, "%d", &ZDATA_P[1][i][j]);
			fscanf(inp7, "%d", &ZDATA_P[2][i][j]);
			fscanf(inp8, "%d", &ZDATA_P[3][i][j]);
			fscanf(inp9, "%d", &ZDATA_P[4][i][j]);
			fscanf(inp0, "%d", &ZDATA_P[5][i][j]);
        }
	fclose(inp1);
	fclose(inp2);
	fclose(inp3);
	fclose(inp4);
	fclose(inp5);
	fclose(inp6);
	fclose(inp7);
	fclose(inp8);
	fclose(inp9);
	fclose(inp0);
	
	inp1 = fopen("DATA/LOJAW_BACK_OCCLUSAL.dat", "r");
	inp2 = fopen("DATA/LOJAW_BACK_MESIAL.dat", "r");
	inp3 = fopen("DATA/LOJAW_BACK_DISTAL.dat", "r");
	inp4 = fopen("DATA/LOJAW_BACK_FACIAL.dat", "r");
	inp5 = fopen("DATA/LOJAW_BACK_LINGUAL.dat", "r");
	inp6 = fopen("DATA/LOJAW_OCCLUSAL.dat", "r");
	inp7 = fopen("DATA/LOJAW_MESIAL.dat", "r");
	inp8 = fopen("DATA/LOJAW_DISTAL.dat", "r");
	inp9 = fopen("DATA/LOJAW_FACIAL.dat", "r");
	inp0 = fopen("DATA/LOJAW_LINGUAL.dat", "r");
	if(inp1 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp2 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp3 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp4 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp5 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp6 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp7 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp8 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp9 == NULL) {printf("Cannot open data file\n"); return 0;}
	if(inp0 == NULL) {printf("Cannot open data file\n"); return 0;}
	for(i = 2; i <= 2 * INDIV; i = i + 2)
		for(j = 1; j <= TOOTH; j++){
			fscanf(inp1, "%d", &ZBACK_P[1][i][j]);
			fscanf(inp2, "%d", &ZBACK_P[2][i][j]);
			fscanf(inp3, "%d", &ZBACK_P[3][i][j]);
			fscanf(inp4, "%d", &ZBACK_P[4][i][j]);
			fscanf(inp5, "%d", &ZBACK_P[5][i][j]);
			fscanf(inp6, "%d", &ZDATA_P[1][i][j]);
			fscanf(inp7, "%d", &ZDATA_P[2][i][j]);
			fscanf(inp8, "%d", &ZDATA_P[3][i][j]);
			fscanf(inp9, "%d", &ZDATA_P[4][i][j]);
			fscanf(inp0, "%d", &ZDATA_P[5][i][j]);
        }
	fclose(inp1);
	fclose(inp2);
	fclose(inp3);
	fclose(inp4);
	fclose(inp5);
	fclose(inp6);
	fclose(inp7);
	fclose(inp8);
	fclose(inp9);
	fclose(inp0);
    
	for(k = 1; k <= nSPAT; k++)
		for(i = 1; i <= 2 * INDIV; i++)
			for(j = 1; j <= TOOTH; j++){
				YBACK_P[k][i][j] = ZBACK_P[k][i][j]; 
				YDATA_P[k][i][j] = ZDATA_P[k][i][j];
				if(YBACK_P[k][i][j] == 1){
					if(YDATA_P[k][i][j] == 2) tmpP1++;
					else tmpP2++;
					if(YDATA_P[k][i][j] == 3) tmpP3++;
					else tmpP4++;
				}
			}
	printf("%d %d %d %d %d %d\n", tmpA1, tmpA2, tmpP1, tmpP2, tmpP3, tmpP4);
    
	double **ZSTAT_P, *STATZ_P, **YSTAT_P, *STATY_P;
	double **ZSTAT_A, *STATZ_A, **YSTAT_A, *STATY_A;
    
	ZSTAT_A = dmatrix(1,     INDIV, 1, nPARA1 + nCOEF1 + 1);
	ZSTAT_P = dmatrix(1, 2 * INDIV, 1, nPARA2 + nCOEF2 + 1);
	YSTAT_A = dmatrix(1,     INDIV, 1, nPARA1 + nCOEF1 + 1);
	YSTAT_P = dmatrix(1, 2 * INDIV, 1, nPARA2 + nCOEF2 + 1);
    
	for(i = 1; i <= INDIV; i++)
		for(j = 1; j <= nPARA1 + nCOEF1 + 1; j++) {ZSTAT_A[i][j] = 0.0; YSTAT_A[i][j] = 0.0;}
    
	for(i = 1; i <= 2 * INDIV; i++)
		for(j = 1; j <= nPARA2 + nCOEF2 + 1; j++) {ZSTAT_P[i][j] = 0.0; YSTAT_P[i][j] = 0.0;}
	
	STATZ_A = dvector(1, nPARA1 + nCOEF1 + 1);
	STATZ_P = dvector(1, nPARA2 + nCOEF2 + 1);
	STATY_A = dvector(1, nPARA1 + nCOEF1 + 1);
	STATY_P = dvector(1, nPARA2 + nCOEF2 + 1);
    
	for(i = 1; i <= nPARA1 + nCOEF1; i++) {STATZ_A[i] = 0.0; STATY_A[i] = 0.0;}
	for(i = 1; i <= nPARA2 + nCOEF2; i++) {STATZ_P[i] = 0.0; STATY_P[i] = 0.0;}
    
	int **Z_A, **Y_A, **Z_P, **Y_P;
	
	Z_A = imatrix(0, 3, 0, TOOTH+1);
	Y_A = imatrix(0, 3, 0, TOOTH+1);
	Z_P = imatrix(1, nSPAT, 1, TOOTH);
	Y_P = imatrix(1, nSPAT, 1, TOOTH);
    
	int **BACK_P, **PREV_P,  **BACK_A, **PREV_A, *OCCL_P, *OCCLBACK_P;
    
	BACK_A = imatrix(0, 3, 0, TOOTH+1);
	PREV_A = imatrix(0, 3, 0, TOOTH+1);
	BACK_P = imatrix(1, nSPAT, 1, TOOTH);
	PREV_P = imatrix(1, nSPAT, 1, TOOTH);
	OCCL_P = ivector(1, TOOTH);
	OCCLBACK_P = ivector(1, TOOTH);
    
	for(k = 1; k <= INDIV; k++){
		for(i = 1; i <= nPARA1 + nCOEF1; i++) ZSTAT_A[k][i] = 0.0;
		for(i = 1; i <= 4; i++)
			for(j = 0; j <= TOOTH + 1; j++){
				BACK_A[(i-1)][j] = ZBACK_A[((k-1)*4+i)][j];
				Z_A[(i-1)][j] = ZDATA_A[((k-1)*4+i)][j];
			}
		cost1(Z_A, BACK_A, STATZ_A, k);
		for(i = 1; i <= nPARA1 + nCOEF1; i++) ZSTAT_A[k][i] = STATZ_A[i];
		Zeffstat_A[k] = STATZ_A[(nPARA1+nCOEF1+1)];
	}
    
	for(i = 1; i <= nPARA1 + nCOEF1; i++) STATZ_A[i] = 0.0;
	for(i = 1; i <= INDIV; i++)
		for(j = 1; j <= nPARA1 + nCOEF1; j++) STATZ_A[j] += ZSTAT_A[i][j];
	for(i = 1; i <= nPARA1 + nCOEF1; i++) printf("STAT%d: %.2f ", i, STATZ_A[i]);
	printf("\n");
    
	for(k = 1; k <= 2 * INDIV; k++){
		if(k % 2 == 1){
			for(j = 1; j <= TOOTH; j++) {
				OCCL_P[j] = ZDATA_P[1][(k+1)][j];
				OCCLBACK_P[j] = ZBACK_P[1][(k+1)][j];
			}
		}
		else{
			for(j = 1; j <= TOOTH; j++) {
				OCCL_P[j] = Z_P[1][j];
				OCCLBACK_P[j] = PREV_P[1][j];
			}
		}
        
		for(i = 1; i <= nSPAT; i++)
			for(j = 1; j <= TOOTH; j++) {Z_P[i][j] = ZDATA_P[i][k][j]; PREV_P[i][j] = ZBACK_P[i][k][j];}
        
		cost2(Z_P, PREV_P, STATZ_P, OCCLBACK_P, OCCL_P, k);
		for(i = 1; i <= nPARA2 + nCOEF2; i++) ZSTAT_P[k][i] = STATZ_P[i];
		Zeffstat_P[k] = STATZ_P[(nPARA2+nCOEF2+1)];
	}
    
	for(i = 1; i <= nPARA2 + nCOEF2; i++) STATZ_P[i] = 0.0;
	for(i = 1; i <= 2 * INDIV; i++){
		for(j = 1; j < nPARA2-2; j++) STATZ_P[j] += ZSTAT_P[i][j];
		if(i % 2 == 0) STATZ_P[(nPARA2-2)] += ZSTAT_P[i][(nPARA2-2)];
		for(j = nPARA2-1; j <= nPARA2+nCOEF2; j++) STATZ_P[j] += ZSTAT_P[i][j];
	}
    
	for(i = 1; i <= nPARA2 + nCOEF2; i++) printf("STAT%d: %.2f ", i, STATZ_P[i]);
	printf("\n");
    
	double **sample_A, **sample_P, **sample_rho, *sample_sigma_A, *sample_sigma_P;
    
	sample_A = dmatrix(1, niter, 1, nPARA1 + nCOEF1);
	sample_P = dmatrix(1, niter, 1, nPARA2 + nCOEF2);
	sample_rho = dmatrix(1, niter, 1, nCORR);
	sample_sigma_A = dvector(1, niter);
	sample_sigma_P = dvector(1, niter);
	
	double *sum_A, *sum_P, *sum_R, *var_A, *var_P, *var_R;
    
	sum_A = dvector(1, nPARA1 + nCOEF1);
	sum_P = dvector(1, nPARA2 + nCOEF2);
	sum_R = dvector(1, nCORR);
	var_A = dvector(1, nPARA1 + nCOEF1);
	var_P = dvector(1, nPARA2 + nCOEF2);
	var_R = dvector(1, nCORR);
    
	double **eff_A, **eff_P, *inv_A, **inv_P, *rho, *newrho;
    
	eff_A = dmatrix(1, niter, 1, INDIV);
	eff_P = dmatrix(1, niter, 1, INDIV);
	inv_A = dvector(1, niter + warm);
	inv_P = dmatrix(1, niter + warm, 1, nCORR);
	newcop_P = dvector(1, nCORR);
	oldcop_P = dvector(1, nCORR);
	rho = dvector(1, nCORR);
	newrho = dvector(1, nCORR);
	gen = dvector(1, nCORR + 1);
	mu  = dvector(1, nCORR + 1);
	Sigma = dmatrix(1, nCORR + 1, 1, nCORR + 1);
	
	for(a = 0; a < REPEAT; a++){
		for(k = 1; k <= INDIV; k++){
			for(i = 1; i <= nPARA1 + nCOEF1; i++) ZSTAT_A[k][i] = 0.0;
			for(i = 1; i <= 4; i++)
				for(j = 0; j <= TOOTH + 1; j++){
					BACK_A[(i-1)][j] = ZBACK_A[((k-1)*4+i)][j];
					Z_A[(i-1)][j] = ZDATA_A[((k-1)*4+i)][j];
				}
			cost1(Z_A, BACK_A, STATZ_A, k);
			for(i = 1; i <= nPARA1 + nCOEF1; i++) ZSTAT_A[k][i] = STATZ_A[i];
			Zeffstat_A[k] = STATZ_A[(nPARA1+nCOEF1+1)];
			Yeffstat_A[k] = Zeffstat_A[k];
		}
		
		for(i = 1; i <= nPARA1 + nCOEF1; i++) STATZ_A[i] = 0.0;
		for(i = 1; i <= INDIV; i++){
			for(j = 1; j <= nPARA1 + nCOEF1; j++) STATZ_A[j] += ZSTAT_A[i][j];
			neweffect_A[i] = 0.0; oldeffect_A[i] = 0.0;
		}
		for(i = 1; i <= nPARA1 + nCOEF1; i++) printf("STAT%d: %.2f ", i, STATZ_A[i]);
		printf("\n");
		
		theta_A[1] = -0.5 + 1.0 * rand() * 1.0 / RAND_MAX;
		theta_A[2] =  0.1 + 0.2 * rand() * 0.2 / RAND_MAX;
		for(k = nPARA1 + 1; k <= nPARA1 + nCOEF1; k++) theta_A[k] = -0.5 + 1.0 * rand() * 1.0 / RAND_MAX;
		for(k = 1; k <= INDIV; k++) oldeffect_A[k] = -0.1 + 0.2 * rand() * 1.0 / RAND_MAX;
		oldsigma_A = 5.0 + 90.0 * rand() * 1.0 / RAND_MAX;

		for(i = 1; i <= 4 * INDIV; i++)
			for(j = 0; j <= TOOTH + 1; j++) {YBACK_A[i][j] = ZBACK_A[i][j]; YDATA_A[i][j] = ZDATA_A[i][j];}
		for(i = 1; i <= INDIV; i++)
			for(j = 1; j <= nPARA1 + nCOEF1; j++) YSTAT_A[i][j] = ZSTAT_A[i][j];

		for(k = 1; k <= nSPAT; k++)
			for(i = 1; i <= 2 * INDIV; i++)
				for(j = 1;  j <= TOOTH; j++) {YBACK_P[k][i][j] = ZBACK_P[k][i][j]; YDATA_P[k][i][j] = ZDATA_P[k][i][j];}
		for(i = 1; i <= 2 * INDIV; i++)
			for(j = 1; j <= nPARA2 + nCOEF2; j++) YSTAT_P[i][j] = 0.0;
        
		for(i = 1; i <= nPARA2 + nCOEF2; i++) STATY_P[i] = 0.0;

		for(k = 1; k <= 2 * INDIV; k++){
			if(k % 2 == 1){
				for(j = 1; j <= TOOTH; j++) {
					OCCL_P[j] = YDATA_P[1][(k+1)][j];
					OCCLBACK_P[j] = YBACK_P[1][(k+1)][j];
				}
			}
			else{
				for(j = 1; j <= TOOTH; j++) {
					OCCL_P[j] = Y_P[1][j];
					OCCLBACK_P[j] = PREV_P[1][j];
				}
			}
			
			for(i = 1; i <= nSPAT; i++)
				for(j = 1; j <= TOOTH; j++) {Y_P[i][j] = YDATA_P[i][k][j]; PREV_P[i][j] = YBACK_P[i][k][j];}
			
			cost2(Y_P, PREV_P, STATY_P, OCCLBACK_P, OCCL_P, k);
			for(i = 1; i <= nPARA2 + nCOEF2; i++) YSTAT_P[k][i] = STATY_P[i];
			Zeffstat_P[k] = STATY_P[(nPARA2 + nCOEF2 + 1)];
			Yeffstat_P[k] = Zeffstat_P[k];
		}
		
		for(i = 1; i <= nPARA2 + nCOEF2; i++) STATY_P[i] = 0.0;
		for(i = 1; i <= 2 * INDIV; i++){
			for(j = 1; j < nPARA2-2; j++) STATY_P[j] += YSTAT_P[i][j];
			if(i % 2 == 0) STATY_P[(nPARA2-2)] += YSTAT_P[i][(nPARA2-2)];
			for(j = nPARA2-1; j <= nPARA2 + nCOEF2; j++) STATY_P[j] += YSTAT_P[i][j];
		}
		
		for(i = 1; i <= nPARA2 + nCOEF2; i++) printf("STAT%d: %.2f ", i, STATY_P[i]);
		printf("\n");
				
		for(i = 1; i <= nPARA2-2; i++) theta_P[i] = 0.1 + 0.4 * rand() * 1.0 / RAND_MAX;
		for(i = nPARA2-1; i <= nPARA2; i++) theta_P[i] = -0.5 + 1.0 * rand() * 1.0 / RAND_MAX;
		for(i = nPARA2+1; i <= nPARA2 + nCOEF2; i++) theta_P[i] = -0.5 + 1.0 * rand() * 1.0 / RAND_MAX;
		for(i = 1; i <= nCORR; i++) rho[i] = -0.2 + 0.4 * rand() * 1.0 / RAND_MAX;
		for(i = 1; i <= INDIV; i++) oldeffect_P[i] = -0.1 + 0.2 * rand() * 1.0 / RAND_MAX;
		oldsigma_P = 5.0 + 90.0 * rand() * 1.0 / RAND_MAX;
		count_A = count_P = count_R = 0;
		accept_A = accept_P = accept_R = 0.0;

		frname[0] = 'R'; frname[1] = 'E'; frname[2] = 'S'; frname[3] = 'U'; frname[4] = 'L'; frname[5] = 'T'; frname[6] = '/';
		frname[10] = '_'; frname[12] = (char)(48+RUNN); frname[13] = '.';
		frname[14] = 'l'; frname[15] = 'o'; frname[16] = 'g'; frname[17] = '\0';
		
		frname[7] = 's'; frname[8] = 'i'; frname[9] = 'm'; 
		frname[11] = 'A'; out1 = fopen(frname, "a");
		frname[11] = 'P'; out2 = fopen(frname, "a");
		frname[11] = 'R'; out3 = fopen(frname, "a");
		frname[7] = 's'; frname[8] = 'e'; frname[9] = 'f'; 
		frname[11] = 'A'; out4 = fopen(frname, "a");
		frname[11] = 'P'; out5 = fopen(frname, "a");
		for(iter = 1; iter <= warm + niter; iter++){
			for(k = 1; k <= nPARA1 + nCOEF1; k++) newtheta_A[k] = theta_A[k] + gasdev() * 0.03;
			newsigma_A = oldsigma_A + gasdev() * 1.0;
			for(k = 1; k <= nPARA2 + nCOEF2; k++) newtheta_P[k] = theta_P[k] + gasdev() * 0.03;
			newsigma_P = oldsigma_P + gasdev() * 1.0;

			indicator_A = 0;
			if(newtheta_A[1] > -1.0 && newtheta_A[1] < 1.0) indicator_A++;
			if(newtheta_A[2] >  0.0 && newtheta_A[2] < 1.0) indicator_A++;

			if(indicator_A == nPARA1){
				for(k = 1; k <= INDIV; k++) Yeffstat_A[k] = Zeffstat_A[k];
				for(r = 0.0, i = 1; i <= nCOEF1; i++){
					r += log((1/(PI*2.5)) * (1/(1+pow((newtheta_A[(nPARA1+i)]/2.5), 2.0))));
					r -= log((1/(PI*2.5)) * (1/(1+pow((theta_A[(nPARA1+i)]/2.5), 2.0))));
				}
				
				for(k = 1; k <= INDIV; k++){
					for(i = 1; i <= 4; i++){
						for(j = 0; j <= TOOTH + 1; j++){
							PREV_A[(i-1)][j] = YBACK_A[((k-1)*4+i)][j];
							Y_A[(i-1)][j] = YDATA_A[((k-1)*4+i)][j];
						}
					}
					for(i = 1; i <= nPARA1 + nCOEF1; i++) STATY_A[i] = 0.0;
					for(i = 1; i <= MM; i++) gibbs1_parameter(Y_A, PREV_A, STATY_A, k);
					for(i = 1; i <= nPARA1 + nCOEF1; i++) YSTAT_A[k][i] = STATY_A[i];
					Yeffstat_A[k] = STATY_A[(nPARA1 + nCOEF1 + 1)];
				}
				
				for(k = 1; k <= nPARA1 + nCOEF1; k++) STATY_A[k] = 0.0;
				for(i = 1; i <= INDIV; i++)
					for(j = 1; j <= nPARA1 + nCOEF1; j++) STATY_A[j] += YSTAT_A[i][j];

				newcop_A = normsinv(newtheta_A[2]); oldcop_A = normsinv(theta_A[2]);
				oldcop_P[1] = normsinv(theta_P[4]/3.0);
				oldcop_P[2] = normsinv(theta_P[5]/3.0);
				oldcop_P[3] = normsinv(theta_P[6]/3.0);

				fyOLD = fxNEW = fxOLD = fyNEW = fxrho = fyrho = 0.0;
				for(i = 1; i <= nPARA1 + nCOEF1; i++){
					fyOLD += theta_A[i] * STATY_A[i];
					fxNEW += newtheta_A[i] * STATZ_A[i];
					fxOLD += theta_A[i] * STATZ_A[i];
					fyNEW += newtheta_A[i] * STATY_A[i];
				}
				for(i = 1; i <= nCORR; i++){
					fyrho += (pow(newcop_A, 2) + pow(oldcop_P[i], 2) - 2 * rho[i] * newcop_A * oldcop_P[i]) / (2.0 * (1 - pow(rho[i], 2)));
					fxrho += (pow(oldcop_A, 2) + pow(oldcop_P[i], 2) - 2 * rho[i] * oldcop_A * oldcop_P[i]) / (2.0 * (1 - pow(rho[i], 2)));
				}
				pr = r + (fyOLD + fxNEW) - (fxOLD + fyNEW) + fyrho - fxrho;
				//printf("iter: %.6d, fyOLD: %.4f, fxNEW: %.4f, fxOLD: %.4f, fyNEW: %.4f\n", iter, fyOLD, fxNEW, fxOLD, fyNEW);			

				if(pr > 0.0) aprob = 1.0;
				else aprob = exp(pr);
				
				U = 0.0; while(U <= 0.0 || U >= 1.0) U = rand() * 1.0 / RAND_MAX;
				if(U < aprob) {
					accept_A += 1.0 / (warm + niter); 
					for(i = 1; i <= nPARA1 + nCOEF1; i++) theta_A[i] = newtheta_A[i];
				}
				else accept_A += 0.0;
			}
			else accept_A += 0.0;
			
			if(newsigma_A > 0.0 && newsigma_A < 100.0){
				for (r = 0.0, k = 1; k <= INDIV; k++) {
					temp_old = oldeffect_A[k];
					r += dlognorm(temp_old, 0, 1/newsigma_A);
					r -= dlognorm(temp_old, 0, 1/oldsigma_A);
				}
				if(r > 0.0) aprob = 1.0;
				else aprob = exp(r);
				
				U = 0.0; while(U <= 0.0 || U > 1.0) U = rand() * 1.0 / RAND_MAX;
				if(U < aprob) oldsigma_A = newsigma_A;
			}
			
			for(b = 1; b <= nLOOP; b++){
				if(b != nLOOP){
					for(k = 1; k <= INDIV; k++) neweffect_A[k] = oldeffect_A[k];
					for(k = 1; k <= INDIV; k++) Yeffstat_A[k] = Zeffstat_A[k];
					for(k = (b - 1) * nRANDOM + 1; k <= b * nRANDOM; k++) neweffect_A[k] = oldeffect_A[k] + gasdev() * 0.01;
					
					for(r = 0.0, k = (b - 1) * nRANDOM + 1; k <= b * nRANDOM; k++) {
						temp_old = oldeffect_A[k]; temp_new = neweffect_A[k];
						r += dlognorm(temp_new, 0, 1/oldsigma_A);
						r -= dlognorm(temp_old, 0, 1/oldsigma_A);
					}
                    
					for(k = (b - 1) * nRANDOM + 1; k <= b * nRANDOM; k++){
						for(i = 1; i <= 4; i++)
							for(j = 0; j <= TOOTH + 1; j++){
								PREV_A[(i-1)][j] = YBACK_A[((k-1)*4+i)][j];
								Y_A[(i-1)][j] = YDATA_A[((k-1)*4+i)][j];
							}
						for(i = 1; i <= nPARA1 + nCOEF1; i++) STATY_A[i] = 0.0;
						for(i = 1; i <= MM; i++) gibbs1_effect(Y_A, PREV_A, STATY_A, k);
						for(i = 1; i <= nPARA1 + nCOEF1; i++) YSTAT_A[k][i] = STATY_A[i];
						Yeffstat_A[k] = STATY_A[(nPARA1 + nCOEF1 + 1)];
					}
                    
					for(k = 1; k <= nPARA1 + nCOEF1; k++) STATY_A[k] = 0.0;
					for(i = 1; i <= INDIV; i++)
						for(j = 1; j <= nPARA1 + nCOEF1; j++) STATY_A[j] += YSTAT_A[i][j];
                    
					fyOLD = fxNEW = fxOLD = fyNEW = 0.0;
					for(i = 1; i <= INDIV; i++){
						fyOLD += oldeffect_A[i] * Yeffstat_A[i];
						fxNEW += neweffect_A[i] * Zeffstat_A[i];
						fxOLD += oldeffect_A[i] * Zeffstat_A[i];
						fyNEW += neweffect_A[i] * Yeffstat_A[i];
					}
					pr = r + (fyOLD + fxNEW) - (fxOLD + fyNEW);
					//printf("iter: %.6d, fyOLD: %.4f, fxNEW: %.4f, fxOLD: %.4f, fyNEW: %.4f\n", iter, fyOLD, fxNEW, fxOLD, fyNEW);
                    
					if(pr > 0.0) aprob = 1.0;
					else aprob = exp(pr);
                    
					U = 0.0; while(U <= 0.0 || U >= 1.0) U = rand() * 1.0 / RAND_MAX;
					if(U < aprob)
						for(k = (b - 1) * nRANDOM + 1; k <= b * nRANDOM; k++) oldeffect_A[k] = neweffect_A[k];
				}
				if(b == nLOOP){
					for(k = 1; k <= INDIV; k++) neweffect_A[k] = oldeffect_A[k];
					for(k = 1; k <= INDIV; k++) Yeffstat_A[k] = Zeffstat_A[k];
					for(k = (b - 1) * nRANDOM + 1; k <= b * nRANDOM + 1; k++) neweffect_A[k] = oldeffect_A[k] + gasdev() * 0.01;
					
					for(r = 0.0, k = (b - 1) * nRANDOM + 1; k <= b * nRANDOM; k++) {
						temp_old = oldeffect_A[k]; temp_new = neweffect_A[k];
						r += dlognorm(temp_new, 0, 1/oldsigma_A);
						r -= dlognorm(temp_old, 0, 1/oldsigma_A);
					}
					
					for(k = (b - 1) * nRANDOM + 1; k <= b * nRANDOM + 1; k++){
						for(i = 1; i <= 4; i++)
							for(j = 0; j <= TOOTH + 1; j++){
								PREV_A[(i-1)][j] = YBACK_A[((k-1)*4+i)][j];
								Y_A[(i-1)][j] = YDATA_A[((k-1)*4+i)][j];
							}
						for(i = 1; i <= nPARA1 + nCOEF1; i++) STATY_A[i] = 0.0;
						for(i = 1; i <= MM; i++) gibbs1_effect(Y_A, PREV_A, STATY_A, k);
						for(i = 1; i <= nPARA1 + nCOEF1; i++) YSTAT_A[k][i] = STATY_A[i];
						Yeffstat_A[k] = STATY_A[(nPARA1 + nCOEF1 + 1)];
					}
                    
					for(k = 1; k <= nPARA1 + nCOEF1; k++) STATY_A[k] = 0.0;
					for(i = 1; i <= INDIV; i++)
						for(j = 1; j <= nPARA1 + nCOEF1; j++) STATY_A[j] += YSTAT_A[i][j];
                    
					fyOLD = fxNEW = fxOLD = fyNEW = 0.0;
					for(i = 1; i <= INDIV; i++){
						fyOLD += oldeffect_A[i] * Yeffstat_A[i];
						fxNEW += neweffect_A[i] * Zeffstat_A[i];
						fxOLD += oldeffect_A[i] * Zeffstat_A[i];
						fyNEW += neweffect_A[i] * Yeffstat_A[i];
					}
					pr = r + (fyOLD + fxNEW) - (fxOLD + fyNEW);
					//printf("iter: %.6d, fyOLD: %.4f, fxNEW: %.4f, fxOLD: %.4f, fyNEW: %.4f\n", iter, fyOLD, fxNEW, fxOLD, fyNEW);
                    
					if(pr > 0.0) aprob = 1.0;
					else aprob = exp(pr);
                    
					U = 0.0; while(U <= 0.0 || U >= 1.0) U = rand() * 1.0 / RAND_MAX;
					if(U < aprob)
						for(k = (b - 1) * nRANDOM + 1; k <= b * nRANDOM + 1; k++) oldeffect_A[k] = neweffect_A[k];
				}
			}
			
			if(iter > warm){
				if(iter % 10 == 0){
					for(i = 1; i <= nPARA1 + nCOEF1; i++) fprintf(out1, " %f", theta_A[i]);
					fprintf(out1, " %f \n", 1.0/oldsigma_A);
					for(i = 1; i <= INDIV; i++) fprintf(out4, " %f", oldeffect_A[i]);
					fprintf(out4, "\n");
				}
				count_A++;
				for(i = 1; i <= nPARA1 + nCOEF1; i++) sample_A[count_A][i] = theta_A[i];
				for(i = 1; i <= INDIV; i++) eff_A[count_A][i] = oldeffect_A[i];
				sample_sigma_A[count_A] = 1.0/oldsigma_A;
			}

			if(iter % 100 == 0){
				printf("%.6d ", iter);
				for(i = 1; i <= nPARA1 + nCOEF1; i++) printf("% .2f ", theta_A[i]);
				printf("% .2f ", 1.0/oldsigma_A);
				printf("\n");
			}

			for(indicator_P = 0, i = 1; i <= nPARA2-2; i++)
				if(newtheta_P[i] > 0.0 && newtheta_P[i] < 3.0) indicator_P++;
			for(i = nPARA2-1; i <= nPARA2; i++)
				if(newtheta_P[i] > -1.0 && newtheta_P[i] < 1.0) indicator_P++;

			if(indicator_P == nPARA2){
				for(k = 1; k <= 2 * INDIV; k++) Yeffstat_P[k] = Zeffstat_P[k];
				for(r = 0.0, i = 1; i <= nCOEF2; i++){
					r += log((1/(PI*2.5)) * (1/(1+pow((newtheta_P[(nPARA2+i)]/2.5), 2.0))));
					r -= log((1/(PI*2.5)) * (1/(1+pow((theta_P[(nPARA2+i)]/2.5), 2.0))));
				}
				
				for(k = 1; k <= 2 * INDIV; k++){
					if(k % 2 == 1){
						for(j = 1; j <= TOOTH; j++) {
							OCCL_P[j] = YDATA_P[1][(k+1)][j];
							OCCLBACK_P[j] = YBACK_P[1][(k+1)][j];
						}
					}
					else{
						for(j = 1; j <= TOOTH; j++) {
							OCCL_P[j] = Y_P[1][j];
							OCCLBACK_P[j] = PREV_P[1][j];
						}
					}
					
					for(i = 1; i <= nPARA2 + nCOEF2; i++) STATY_P[i] = ZSTAT_P[k][i];
					for(i = 1; i <= nSPAT; i++){
						for(j = 1; j <= TOOTH; j++) {
							Y_P[i][j] = YDATA_P[i][k][j]; 
							PREV_P[i][j] = YBACK_P[i][k][j];
						}
					}
					
					for(i = 1; i <= MM; i++) gibbs2_parameter(Y_P, PREV_P, STATY_P, OCCLBACK_P, OCCL_P, k);
					for(i = 1; i <= nPARA2 + nCOEF2; i++) YSTAT_P[k][i] = STATY_P[i];
					Yeffstat_P[k] = STATY_P[(nPARA2 + nCOEF2 + 1)];
				}
				
				for(k = 1; k <= nPARA2 + nCOEF2; k++) STATY_P[k] = 0.0;
				for(i = 1; i <= 2 * INDIV; i++){
					for(j = 1; j < nPARA2-2; j++) STATY_P[j] += YSTAT_P[i][j];
					if(i % 2 == 0) STATY_P[(nPARA2-2)] += YSTAT_P[i][(nPARA2-2)];
					for(j = nPARA2-1; j <= nPARA2 + nCOEF2; j++) STATY_P[j] += YSTAT_P[i][j];
				}

				oldcop_A = normsinv(theta_A[2]);
				oldcop_P[1] = normsinv(theta_P[4]/3.0); newcop_P[1] = normsinv(newtheta_P[4]/3.0);
				oldcop_P[2] = normsinv(theta_P[5]/3.0); newcop_P[2] = normsinv(newtheta_P[5]/3.0);
				oldcop_P[3] = normsinv(theta_P[6]/3.0); newcop_P[3] = normsinv(newtheta_P[6]/3.0);
				
				fyOLD = fxNEW = fxOLD = fyNEW = fxrho = fyrho = 0.0;
				for(i = 1; i <= nPARA2 + nCOEF2; i++){
					fyOLD += theta_P[i] * STATY_P[i];
					fxNEW += newtheta_P[i] * STATZ_P[i];
					fxOLD += theta_P[i] * STATZ_P[i];
					fyNEW += newtheta_P[i] * STATY_P[i];
				}
				for(i = 1; i <= nCORR; i++){
					fyrho += (pow(oldcop_A, 2) + pow(newcop_P[i], 2) - 2 * rho[i] * oldcop_A * newcop_P[i]) / (2.0 * (1 - pow(rho[i], 2)));
					fxrho += (pow(oldcop_A, 2) + pow(oldcop_P[i], 2) - 2 * rho[i] * oldcop_A * oldcop_P[i]) / (2.0 * (1 - pow(rho[i], 2)));
				}
				pr = r + (fyOLD + fxNEW) - (fxOLD + fyNEW) + fyrho - fxrho;
				//printf("fyOLD: %f, fxNEW: %f, fxOLD: %f, fyNEW: %f\n", fyOLD, fxNEW, fxOLD, fyNEW);
				
				if(pr > 0.0) aprob = 1.0;
				else aprob = exp(pr);
				
				U = 0.0; while(U <= 0.0 || U >= 1.0) U = rand() * 1.0 / RAND_MAX;
				if(U < aprob) {
					accept_P += 1.0 / (warm + niter); 
					for(i = 1; i <= nPARA2 + nCOEF2; i++) theta_P[i] = newtheta_P[i];
				}
				else accept_P += 0.0;                
			}
			else accept_P += 0.0;
			
			if(newsigma_P > 0.0 && newsigma_P < 100.0){
				for (r = 0.0, k = 1; k <= INDIV; k++) {
					temp_old = oldeffect_P[k];
					r += dlognorm(temp_old, 0, 1/newsigma_P);
					r -= dlognorm(temp_old, 0, 1/oldsigma_P);
				}
				if(r > 0.0) aprob = 1.0;
				else aprob = exp(r);
				
				U = 0.0; while(U <= 0.0 || U > 1.0) U = rand() * 1.0 / RAND_MAX;
				if(U < aprob) oldsigma_P = newsigma_P;
			}
			
			for(b = 1; b <= nLOOP; b++){
				if(b != nLOOP){
					for(k = 1; k <= INDIV; k++) neweffect_P[k] = oldeffect_P[k];
					for(k = (b - 1) * nRANDOM + 1; k <= b * nRANDOM; k++) neweffect_P[k] = oldeffect_P[k] + gasdev() * 0.01;
					for(k = 1; k <= 2 * INDIV; k++) Yeffstat_P[k] = Zeffstat_P[k];
					
					for(r = 0.0, k = (b - 1) * nRANDOM + 1; k <= b * nRANDOM; k++) {
						temp_old = oldeffect_P[k]; temp_new = neweffect_P[k];
						r += dlognorm(temp_new, 0, 1/oldsigma_P);
						r -= dlognorm(temp_old, 0, 1/oldsigma_P);
					}

					for(k = 2 * (b - 1) * nRANDOM + 1; k <= 2 * b * nRANDOM; k++){
						if(k % 2 == 1){
							for(j = 1; j <= TOOTH; j++) {
								OCCL_P[j] = YDATA_P[1][(k+1)][j];
								OCCLBACK_P[j] = YBACK_P[1][(k+1)][j];
							}
						}
						else{
							for(j = 1; j <= TOOTH; j++) {
								OCCL_P[j] = Y_P[1][j];
								OCCLBACK_P[j] = PREV_P[1][j];
							}
						}
                        
						for(i = 1; i <= nPARA2 + nCOEF2; i++) STATY_P[i] = ZSTAT_P[k][i];
						for(i = 1; i <= nSPAT; i++){
							for(j = 1; j <= TOOTH; j++) {
								Y_P[i][j] = YDATA_P[i][k][j];
								PREV_P[i][j] = YBACK_P[i][k][j];
							}
						}
                        
						for(i = 1; i <= MM; i++) gibbs2_effect(Y_P, PREV_P, STATY_P, OCCLBACK_P, OCCL_P, k);
						for(i = 1; i <= nPARA2 + nCOEF2; i++) YSTAT_P[k][i] = STATY_P[i];
						Yeffstat_P[k] = STATY_P[(nPARA2 + nCOEF2 + 1)];
					}
                    
					for(k = 1; k <= nPARA2 + nCOEF2; k++) STATY_P[k] = 0.0;
					for(i = 1; i <= 2 * INDIV; i++){
						for(j = 1; j < nPARA2-2; j++) STATY_P[j] += YSTAT_P[i][j];
						if(i % 2 == 0) STATY_P[(nPARA2-2)] += YSTAT_P[i][(nPARA2-2)];
						for(j = nPARA2-1; j <= nPARA2 + nCOEF2; j++) STATY_P[j] += YSTAT_P[i][j];
					}
                    
					fyOLD = fxNEW = fxOLD = fyNEW = 0.0;
					for(i = 1; i <= INDIV; i++){
						fyOLD += oldeffect_P[i] * (Yeffstat_P[(i*2-1)] + Yeffstat_P[(i*2)]);
						fxNEW += neweffect_P[i] * (Zeffstat_P[(i*2-1)] + Zeffstat_P[(i*2)]);
						fxOLD += oldeffect_P[i] * (Zeffstat_P[(i*2-1)] + Zeffstat_P[(i*2)]);
						fyNEW += neweffect_P[i] * (Yeffstat_P[(i*2-1)] + Yeffstat_P[(i*2)]);
					}
					pr = r + (fyOLD + fxNEW) - (fxOLD + fyNEW);
					//printf("iter: %.6d, fyOLD: %.4f, fxNEW: %.4f, fxOLD: %.4f, fyNEW: %.4f\n", iter, fyOLD, fxNEW, fxOLD, fyNEW);
                    
					if(pr > 0.0) aprob = 1.0;
					else aprob = exp(pr);
                    
					U = 0.0; while(U <= 0.0 || U >= 1.0) U = rand() * 1.0 / RAND_MAX;
					if(U < aprob)
						for(k = (b - 1) * nRANDOM + 1; k <= b * nRANDOM; k++) oldeffect_P[k] = neweffect_P[k];
				}
				if(b == nLOOP){
					for(k = 1; k <= INDIV; k++) neweffect_P[k] = oldeffect_P[k];
					for(k = (b - 1) * nRANDOM + 1; k <= b * nRANDOM + 1; k++) neweffect_P[k] = oldeffect_P[k] + gasdev() * 0.01;
					for(k = 1; k <= 2 * INDIV; k++) Yeffstat_P[k] = Zeffstat_P[k];
					
					for(r = 0.0, k = (b - 1) * nRANDOM + 1; k <= b * nRANDOM; k++) {
						temp_old = oldeffect_P[k]; temp_new = neweffect_P[k];
						r += dlognorm(temp_new, 0, 1/oldsigma_P);
						r -= dlognorm(temp_old, 0, 1/oldsigma_P);
					}

					for(k = 2 * (b - 1) * nRANDOM + 1; k <= 2 * b * nRANDOM + 1; k++){
						if(k % 2 == 1){
							for(j = 1; j <= TOOTH; j++) {
								OCCL_P[j] = YDATA_P[1][(k+1)][j];
								OCCLBACK_P[j] = YBACK_P[1][(k+1)][j];
							}
						}
						else{
							for(j = 1; j <= TOOTH; j++) {
								OCCL_P[j] = Y_P[1][j];
								OCCLBACK_P[j] = PREV_P[1][j];
							}
						}
                        
						for(i = 1; i <= nPARA2 + nCOEF2; i++) STATY_P[i] = ZSTAT_P[k][i];
						for(i = 1; i <= nSPAT; i++){
							for(j = 1; j <= TOOTH; j++) {
								Y_P[i][j] = YDATA_P[i][k][j];
								PREV_P[i][j] = YBACK_P[i][k][j];
							}
						}
                        
						for(i = 1; i <= MM; i++) gibbs2_effect(Y_P, PREV_P, STATY_P, OCCLBACK_P, OCCL_P, k);
						for(i = 1; i <= nPARA2 + nCOEF2; i++) YSTAT_P[k][i] = STATY_P[i];
						Yeffstat_P[k] = STATY_P[(nPARA2 + nCOEF2 + 1)];
					}
                    
					for(k = 1; k <= nPARA2 + nCOEF2; k++) STATY_P[k] = 0.0;
					for(i = 1; i <= 2 * INDIV; i++){
						for(j = 1; j < nPARA2-2; j++) STATY_P[j] += YSTAT_P[i][j];
						if(i % 2 == 0) STATY_P[(nPARA2-2)] += YSTAT_P[i][(nPARA2-2)];
						for(j = nPARA2-1; j <= nPARA2 + nCOEF2; j++) STATY_P[j] += YSTAT_P[i][j];
					}
                    
					fyOLD = fxNEW = fxOLD = fyNEW = 0.0;
					for(i = 1; i <= INDIV; i++){
						fyOLD += oldeffect_P[i] * (Yeffstat_P[(i*2-1)] + Yeffstat_P[(i*2)]);
						fxNEW += neweffect_P[i] * (Zeffstat_P[(i*2-1)] + Zeffstat_P[(i*2)]);
						fxOLD += oldeffect_P[i] * (Zeffstat_P[(i*2-1)] + Zeffstat_P[(i*2)]);
						fyNEW += neweffect_P[i] * (Yeffstat_P[(i*2-1)] + Yeffstat_P[(i*2)]);
					}
					pr = r + (fyOLD + fxNEW) - (fxOLD + fyNEW);
					//printf("iter: %.6d, fyOLD: %.4f, fxNEW: %.4f, fxOLD: %.4f, fyNEW: %.4f\n", iter, fyOLD, fxNEW, fxOLD, fyNEW);
                    
					if(pr > 0.0) aprob = 1.0;
					else aprob = exp(pr);
                    
					U = 0.0; while(U <= 0.0 || U >= 1.0) U = rand() * 1.0 / RAND_MAX;
					if(U < aprob)
						for(k = (b - 1) * nRANDOM + 1; k <= b * nRANDOM + 1; k++) oldeffect_P[k] = neweffect_P[k];
				}						
			}
						
			if(iter > warm){
				if(iter % 10 == 0){
					for(i = 1; i <= nPARA2 + nCOEF2; i++) fprintf(out2, " %f", theta_P[i]);
					fprintf(out2, " %f \n", 1.0/oldsigma_P);
					for(i = 1; i <= INDIV; i++) fprintf(out5, " %f", oldeffect_P[i]);
					fprintf(out5, "\n");
				}
				count_P++;
				for(i = 1; i <= nPARA2 + nCOEF2; i++) sample_P[count_P][i] = theta_P[i];
				for(i = 1; i <= INDIV; i++) eff_P[count_P][i] = oldeffect_P[i];
				sample_sigma_P[count_P] = 1.0/oldsigma_P;                
			}

			if(iter % 100 == 0){
				printf("%.6d ", iter);
				for(i = 1; i <= nPARA2 + nCOEF2; i++) printf("% .2f ", theta_P[i]);
				printf("% .2f ", 1.0/oldsigma_P);
				printf("\n");
			}
			
			inv_A[iter] = normsinv(theta_A[2]);
			inv_P[iter][1] = normsinv(theta_P[4]/3.0);
			inv_P[iter][2] = normsinv(theta_P[5]/3.0);
			inv_P[iter][3] = normsinv(theta_P[6]/3.0);

			for(k = 1; k <= nCORR; k++) newrho[k] = rho[k] + gasdev() * 0.1;

			indicator_R = 0; 
			for(k = 1; k <= nCORR; k++)
				if(newrho[k] > -1.0 && newrho[k] < 1.0) indicator_R++;

			if(indicator_R == nCORR){
				fxrho = fyrho = 0.0;
				for(k = 1; k <= nCORR; k++){
					for(i = 1; i <= iter; i++){
						fxrho += - 0.5 * log(1 - pow(rho[k], 2)); 
						fxrho -= (pow(inv_A[i], 2) + pow(inv_P[i][k], 2) - 2.0 * rho[k] * inv_A[i] * inv_P[i][k]) / (2.0 * (1 - pow(rho[k], 2)));
						fyrho += - 0.5 * log(1 - pow(newrho[k], 2)); 
						fyrho -= (pow(inv_A[i], 2) + pow(inv_P[i][k], 2) - 2.0 * newrho[k] * inv_A[i] * inv_P[i][k]) / (2.0 * (1 - pow(newrho[k], 2)));
					}
				}
				pr = fyrho - fxrho;
				
				if(pr > 0.0) aprob = 1.0;
				else aprob = exp(pr);
				
				U = 0.0; while(U <= 0.0 || U >= 1.0) U = rand() * 1.0 / RAND_MAX;
				if(U < aprob) {
					accept_R += 1.0 / (warm + niter); 
					for(k = 1; k <= nCORR; k++) rho[k] = newrho[k];
				}
				else accept_R += 0;				
			}
			else accept_R += 0;

			if(iter > warm){
				if(iter % 10 == 0){
					for(i = 1; i <= nCORR; i++) fprintf(out3, " %f", rho[i]);
					fprintf(out3, "\n");
				}
				count_R++;
				for(i = 1; i <= nCORR; i++) sample_rho[count_R][i] = rho[i];
			}
			
			if(iter % 100 == 0){
				printf("%.6d ", iter);
				for(i = 1; i <= nCORR; i++) printf("% .2f ", rho[i]);
				printf("\n");
			}
		}
		fclose(out1);
		fclose(out2);
		fclose(out3);
		fclose(out4);
		fclose(out5);

		for(i = 1; i <= nPARA1 + nCOEF1; i++) sum_A[i] = theta_A[i] = 0.0;
		for(i = 1; i <= INDIV; i++) oldeffect_A[i] = 0.0;
		oldsigma_A = 0.0;
		for(k = 1; k <= count_A; k++){
			for(i = 1; i <= nPARA1 + nCOEF1; i++){
				theta_A[i] += sample_A[k][i];
				sum_A[i]  += sample_A[k][i] * sample_A[k][i];
			}
			oldsigma_A += sample_sigma_A[k] / count_A;
			for(i = 1; i <= INDIV; i++) oldeffect_A[i] += eff_A[k][i] / count_A;
		}
		for(i = 1; i <= nPARA1 + nCOEF1; i++){
			theta_A[i] /= count_A;
			var_A[i] = (sum_A[i] - theta_A[i] * theta_A[i] * count_A) / (count_A - 1);
		}
		for(i = 1; i <= nPARA2 + nCOEF2; i++) sum_P[i] = theta_P[i] = 0.0;
		for(i = 1; i <= INDIV; i++) oldeffect_P[i] = 0.0;
		oldsigma_P = 0.0;
		for(k = 1; k <= count_P; k++){
			for(i = 1; i <= nPARA2 + nCOEF2; i++){
				theta_P[i] += sample_P[k][i];
				sum_P[i]  += sample_P[k][i] * sample_P[k][i];
			}
			oldsigma_P += sample_sigma_P[k] / count_P;
			for(i = 1; i <= INDIV; i++) oldeffect_P[i] += eff_P[k][i] / count_P;
		}
		for(i = 1; i <= nPARA2 + nCOEF2; i++){
			theta_P[i] /= count_P;
			var_P[i] = (sum_P[i] - theta_P[i] * theta_P[i] * count_P) / (count_P - 1);
		}
		for(i = 1; i <= nCORR; i++) sum_R[i] = rho[i] = 0.0;
		for(k = 1; k <= count_R; k++){
			for(i = 1; i <= nCORR; i++){
				rho[i] += sample_rho[k][i];
				sum_R[i]  += sample_rho[k][i] * sample_rho[k][i];
			}
		}
		for(i = 1; i <= nCORR; i++){
			rho[i] /= count_R;
			var_R[i] = (sum_R[i] - rho[i] * rho[i] * count_R) / (count_R - 1);
		}
	
		out1 = fopen("RESULT/sum.log", "a");
		fprintf(out1, " %d", a);
		for(i = 1; i <= nPARA1 + nCOEF1; i++) fprintf(out1, " %f", theta_A[i]);
		fprintf(out1, " %f", oldsigma_A);
		for(i = 1; i <= nPARA2 + nCOEF2; i++) fprintf(out1, " %f", theta_P[i]);
		fprintf(out1, " %f", oldsigma_P);
		for(i = 1; i <= nCORR; i++) fprintf(out1, " %f", rho[i]);
		fprintf(out1, "\n");
		fprintf(out1, "%.3f %.3f %.3f\n", accept_A, accept_P, accept_R);
		fclose(out1);
		
		printf("ITER: %d ", a);
		for(i = 1; i <= nPARA1 + nCOEF1; i++) printf("BETA%d: %.2f ", i, theta_A[i]);
		printf("SIGMA: %.2f ", oldsigma_A);
		printf("\n");
		for(i = 1; i <= nPARA2 + nCOEF2; i++) printf("BETA%d: %.2f ", i, theta_P[i]);
		printf("SIGMA: %.2f ", oldsigma_P);
		printf("\n");
		for(i = 1; i <= nCORR; i++) printf("RHO%d: %.2f ", i, rho[i]);
		printf("\n");
		printf("Accept_A: %.2f, Accept_P: %.2f, Accept_R: %.2f\n", accept_A, accept_P, accept_R);
		
		out1 = fopen("RESULT/effA.log", "a");
		out2 = fopen("RESULT/effP.log", "a");
		for(i = 1; i <= INDIV; i++) fprintf(out1, " %f", oldeffect_A[i]);
		for(i = 1; i <= INDIV; i++) fprintf(out2, " %f", oldeffect_P[i]);
		fprintf(out1, "\n");
		fprintf(out2, "\n");
		fclose(out1);
		fclose(out2);
	}

	free_dmatrix(COV, 1, INDIV, 1, nCOV);
	free_dmatrix(COEF_A, 1, INDIV, 1, nCOEF1);
	free_dmatrix(COEF_P, 1, 2 * INDIV, 1, nCOEF2);
	free_dvector(prop, 1, nCOEF2);

	free_dvector(Yeffstat_A, 1,     INDIV);
	free_dvector(Zeffstat_A, 1,     INDIV);
	free_dvector(Yeffstat_P, 1, 2 * INDIV);
	free_dvector(Zeffstat_P, 1, 2 * INDIV);

	free_dvector(theta_A,    1, nPARA1 + nCOEF1);
	free_dvector(theta_P,    1, nPARA2 + nCOEF2);
	free_dvector(newtheta_A, 1, nPARA1 + nCOEF1);
	free_dvector(newtheta_P, 1, nPARA2 + nCOEF2);

	free_dvector(neweffect_A, 1, INDIV);
	free_dvector(neweffect_P, 1, INDIV);
	free_dvector(oldeffect_A, 1, INDIV);
	free_dvector(oldeffect_P, 1, INDIV);

	free_imatrix(ZBACK_A, 1, 4 * INDIV, 0, TOOTH + 1);
	free_imatrix(ZDATA_A, 1, 4 * INDIV, 0, TOOTH + 1);
	free_imatrix(YBACK_A, 1, 4 * INDIV, 0, TOOTH + 1);
	free_imatrix(YDATA_A, 1, 4 * INDIV, 0, TOOTH + 1);

	free_dmatrix(ZSTAT_A, 1,     INDIV, 1, nPARA1 + nCOEF1 + 1);
	free_dmatrix(ZSTAT_P, 1, 2 * INDIV, 1, nPARA2 + nCOEF1 + 1);
	free_dmatrix(YSTAT_A, 1,     INDIV, 1, nPARA1 + nCOEF1 + 1);
	free_dmatrix(YSTAT_P, 1, 2 * INDIV, 1, nPARA2 + nCOEF2 + 1);

	free_dvector(STATZ_A, 1, nPARA1 + nCOEF1 + 1);
	free_dvector(STATZ_P, 1, nPARA2 + nCOEF2 + 1);
	free_dvector(STATY_A, 1, nPARA1 + nCOEF1 + 1);
	free_dvector(STATY_P, 1, nPARA2 + nCOEF2 + 1);

	free_imatrix(Z_A, 0, 3, 0, TOOTH+1);
	free_imatrix(Y_A, 0, 3, 0, TOOTH+1);
	free_imatrix(Z_P, 1, nSPAT, 1, TOOTH);
	free_imatrix(Y_P, 1, nSPAT, 1, TOOTH);

	free_imatrix(BACK_A, 0, 3, 0, TOOTH+1);
	free_imatrix(PREV_A, 0, 3, 0, TOOTH+1);
	free_imatrix(BACK_P, 1, nSPAT, 1, TOOTH);
	free_imatrix(PREV_P, 1, nSPAT, 1, TOOTH);
	free_ivector(OCCL_P, 1, TOOTH);
	free_ivector(OCCLBACK_P, 1, TOOTH);

	free_dmatrix(sample_A, 1, niter, 1, nPARA1 + nCOEF1);
	free_dmatrix(sample_P, 1, niter, 1, nPARA2 + nCOEF2);
	free_dmatrix(sample_rho, 1, niter, 1, nCORR);
	free_dvector(sample_sigma_A, 1, niter);
	free_dvector(sample_sigma_P, 1, niter);

	free_dvector(sum_A, 1, nPARA1 + nCOEF1);
	free_dvector(sum_P, 1, nPARA2 + nCOEF2);
	free_dvector(sum_R, 1, nCORR);
	free_dvector(var_A, 1, nPARA1 + nCOEF1);
	free_dvector(var_P, 1, nPARA2 + nCOEF2);
	free_dvector(var_R, 1, nCORR);

	free_dmatrix(eff_A, 1, niter, 1, INDIV);
	free_dmatrix(eff_P, 1, niter, 1, INDIV);

	free_dvector(inv_A, 1, niter + warm);
	free_dmatrix(inv_P, 1, niter + warm, 1, nCORR);
	free_dvector(rho, 1, nCORR);
	free_dvector(newrho, 1, nCORR);

	free_dvector(gen, 1, nCORR + 1);
        free_dvector(mu, 1, nCORR + 1);
        free_dmatrix(Sigma, 1, nCORR + 1, 1, nCORR + 1);

	return 0;
}
